# coding: utf-8

"""
    User Service API

    Solomon AI User Service API - Manages user profiles and authentication

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@solomon-ai.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from solomonai_backend_client_sdk.models.api_key_environment import APIKeyEnvironment
from solomonai_backend_client_sdk.models.scope_type import ScopeType
from typing import Optional, Set
from typing_extensions import Self

class CreateOrganizationApiKeyRequest(BaseModel):
    """
    CreateOrganizationApiKeyRequest
    """ # noqa: E501
    organization_id: StrictStr = Field(alias="organizationId")
    owner_supabase_auth_user_id: StrictStr = Field(alias="ownerSupabaseAuthUserId")
    key_name: StrictStr = Field(alias="keyName")
    scopes: Optional[List[ScopeType]] = None
    rate_limit: Optional[StrictInt] = Field(default=None, alias="rateLimit")
    allowed_ips: Optional[List[StrictStr]] = Field(default=None, alias="allowedIps")
    allowed_domains: Optional[List[StrictStr]] = Field(default=None, alias="allowedDomains")
    max_usage_count: Optional[StrictInt] = Field(default=None, alias="maxUsageCount")
    environment: Optional[APIKeyEnvironment] = APIKeyEnvironment.UNSPECIFIED
    expires_at: Optional[datetime] = Field(default=None, alias="expiresAt")
    __properties: ClassVar[List[str]] = ["organizationId", "ownerSupabaseAuthUserId", "keyName", "scopes", "rateLimit", "allowedIps", "allowedDomains", "maxUsageCount", "environment", "expiresAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateOrganizationApiKeyRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateOrganizationApiKeyRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "organizationId": obj.get("organizationId"),
            "ownerSupabaseAuthUserId": obj.get("ownerSupabaseAuthUserId"),
            "keyName": obj.get("keyName"),
            "scopes": obj.get("scopes"),
            "rateLimit": obj.get("rateLimit"),
            "allowedIps": obj.get("allowedIps"),
            "allowedDomains": obj.get("allowedDomains"),
            "maxUsageCount": obj.get("maxUsageCount"),
            "environment": obj.get("environment") if obj.get("environment") is not None else APIKeyEnvironment.UNSPECIFIED,
            "expiresAt": obj.get("expiresAt")
        })
        return _obj


