# coding: utf-8

"""
    User Service API

    Solomon AI User Service API - Manages user profiles and authentication

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@solomon-ai.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class InternalErrorCode(str, Enum):
    """
    - INTERNAL_ERROR: General internal errors  - RESOURCE_EXHAUSTED: Resource exhaustion errors  - CANCELLED: Operation errors  - UNAVAILABLE: Availability errors  - DEPENDENCY_FAILURE: New internal error codes  Failure in external dependency  - CONFIGURATION_ERROR: Service configuration error  - SECURITY_BREACH_DETECTED: Potential security breach detected
    """

    """
    allowed enum values
    """
    NO_INTERNAL_ERROR = 'NO_INTERNAL_ERROR'
    INTERNAL_ERROR = 'INTERNAL_ERROR'
    DATA_CORRUPTION = 'DATA_CORRUPTION'
    DATABASE_ERROR = 'DATABASE_ERROR'
    CACHE_ERROR = 'CACHE_ERROR'
    RESOURCE_EXHAUSTED = 'RESOURCE_EXHAUSTED'
    QUOTA_EXCEEDED = 'QUOTA_EXCEEDED'
    RATE_LIMIT_EXCEEDED = 'RATE_LIMIT_EXCEEDED'
    CANCELLED = 'CANCELLED'
    DEADLINE_EXCEEDED = 'DEADLINE_EXCEEDED'
    ALREADY_EXISTS = 'ALREADY_EXISTS'
    FAILED_PRECONDITION = 'FAILED_PRECONDITION'
    ABORTED = 'ABORTED'
    OUT_OF_RANGE = 'OUT_OF_RANGE'
    UNAVAILABLE = 'UNAVAILABLE'
    DATA_LOSS = 'DATA_LOSS'
    SERVICE_DEGRADED = 'SERVICE_DEGRADED'
    DEPENDENCY_FAILURE = 'DEPENDENCY_FAILURE'
    CONFIGURATION_ERROR = 'CONFIGURATION_ERROR'
    SECURITY_BREACH_DETECTED = 'SECURITY_BREACH_DETECTED'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of InternalErrorCode from a JSON string"""
        return cls(json.loads(json_str))


