# coding: utf-8

"""
    User Service API

    Solomon AI User Service API - Manages user profiles and authentication

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@solomon-ai.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from solomonai_backend_client_sdk.models.publication_type import PublicationType
from typing import Optional, Set
from typing_extensions import Self

class Publication(BaseModel):
    """
    Use Case - An online magazine, a publication with a fixed publication staff that posts stories around a specific topic - A community publication, a publication that accepts stories published around Medium - A company blog, a publication that is created specifically to share company news - A collection of individual stories by a single author that are parts of a larger whole
    """ # noqa: E501
    id: Optional[StrictStr] = None
    post_ids: Optional[List[StrictStr]] = Field(default=None, alias="postIds")
    admin: Optional[UserProfile] = None
    admin_backend_platform_user_id: StrictStr = Field(alias="adminBackendPlatformUserId")
    tags: List[StrictStr]
    editors: Optional[List[UserProfile]] = None
    subjects: List[StrictStr]
    description: Optional[StrictStr] = None
    created_at: Optional[StrictStr] = Field(default=None, alias="createdAt")
    type: PublicationType
    publication_name: StrictStr = Field(alias="publicationName")
    __properties: ClassVar[List[str]] = ["id", "postIds", "admin", "adminBackendPlatformUserId", "tags", "editors", "subjects", "description", "createdAt", "type", "publicationName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Publication from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of admin
        if self.admin:
            _dict['admin'] = self.admin.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in editors (list)
        _items = []
        if self.editors:
            for _item in self.editors:
                if _item:
                    _items.append(_item.to_dict())
            _dict['editors'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Publication from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "postIds": obj.get("postIds"),
            "admin": UserProfile.from_dict(obj["admin"]) if obj.get("admin") is not None else None,
            "adminBackendPlatformUserId": obj.get("adminBackendPlatformUserId"),
            "tags": obj.get("tags"),
            "editors": [UserProfile.from_dict(_item) for _item in obj["editors"]] if obj.get("editors") is not None else None,
            "subjects": obj.get("subjects"),
            "description": obj.get("description"),
            "createdAt": obj.get("createdAt"),
            "type": obj.get("type") if obj.get("type") is not None else PublicationType.UNSPECIFIED,
            "publicationName": obj.get("publicationName")
        })
        return _obj

from solomonai_backend_client_sdk.models.user_profile import UserProfile
# TODO: Rewrite to not use raise_errors
Publication.model_rebuild(raise_errors=False)

